<?php


##########################
#requires utils.php found in wizard
#original utils.php from  http://doug.warner.fm/nagios-utilsphp-script-for-php-plugins.html
##########################

#w warning
#c critical
#k key to pull
#h additional header
#s string or not
#r result code to return if string matches
#n result code to return if string doesn't match

include 'utils.php';

$options = getopt("w:c:k:u:h:s:r:n:x:");

$ch = curl_init();
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_URL, $options["u"]);
curl_setopt($ch, CURLOPT_HTTPHEADER, array('Accept: application/json'));

if (isset($options["h"])){
	curl_setopt($ch, CURLOPT_HTTPHEADER, array('Accept: application/json', $options["h"]));
}

$chData=curl_exec($ch);
$chDataArray=json_decode($chData,TRUE);

curl_close($ch);

if (isset($options["k"])) {
    $associative_keys = explode(".", $options["k"]);
    $current_arr = $chDataArray;
    foreach ($associative_keys as $key) {
        if (isset($current_arr[$key])) {
            $current_arr = $current_arr[$key];
        } else {
            break;
        }
    }
}

if (isset($options["x"])) {
    $associative_keys = explode(".", $options["x"]);
    $current_arrk = $chDataArray;
    foreach ($associative_keys as $key) {
        if (isset($current_arrk[$key])) {
            $current_arrk = $current_arrk[$key];
        } else {
            break;
        }
    }
}


if (isset($options["w"])){
	$warning = new Nagios_Plugin_Range($options["w"]);
}

if (isset($options["c"])){
$critical = new Nagios_Plugin_Range($options["c"]);
}

if (isset($options["x"])){
	$return_key = $current_arrk;
}else{
	$return_key = $current_arr;
}

if (!isset($options["s"])){
	if($critical->check_range($current_arr)){
    	echo "CRITICAL! " . $options["k"] . "@" . $return_key . "|" . $options["k"] . "=" . $return_key . "\n";
    	exit(2);
	}

	if($warning->check_range($current_arr)){
   	 echo "WARNING! " . $options["k"] . "@" . $return_key . "|" . $options["k"] . "=" . $return_key . "\n";
   	 exit(1);
	}

	echo "OK! " . $options["k"] . "@" . $return_key . "|" . $options["k"] . "=" . $return_key . "\n";
	exit(0);
}
else {
	$match_status_code = $options["r"];
	$no_match_status_code = $options["n"];

	$string = $options["s"];

	
	if (preg_match($string,$current_arr)||$string==$current_arr){
		echo "match! $return_key\n";
		exit(intval($match_status_code));
	}
	else {
		echo "no match! $return_key\n"; 
		exit(intval($no_match_status_code));
	}
}

?> 
